#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] Icon",
	author = "R1KO",
	version = "1.0.1"
};

new const String:g_sFeature[] = "Icon";

new g_iIcon[MAXPLAYERS+1] = {-1, ...};

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, STRING, _, OnToggleItem);
	
	VIP_HookClientSpawn(OnPlayerSpawn);

	HookEvent("player_death",	Event_KillIcon);
	HookEvent("player_team",	Event_KillIcon);
}

public Action:OnToggleItem(iClient, const String:sFeatureName[], VIP_ToggleState:OldStatus, &VIP_ToggleState:NewStatus)
{
	if(NewStatus == ENABLED)
	{
		CreateIcon(iClient);
	}
	else
	{
		RemoveIcon(iClient);
	}

	return Plugin_Continue;
}

public Event_KillIcon(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{	
	RemoveIcon(GetClientOfUserId(GetEventInt(hEvent, "userid")));
}

public OnPlayerSpawn(iClient, iTeam, bool:bIsVIP)
{
	if(bIsVIP && VIP_IsClientFeatureUse(iClient, g_sFeature))
	{
		RemoveIcon(iClient);
		CreateIcon(iClient);
	}
}

public VIP_OnVIPClientLoaded(iClient)
{
	if(VIP_GetClientFeatureStatus(iClient, g_sFeature) != NO_ACCESS)
	{
		decl String:sModel[PLATFORM_MAX_PATH];
		VIP_GetClientFeatureString(iClient, g_sFeature, sModel, sizeof(sModel));
		PrecacheModel(sModel);
	}
}

RemoveIcon(iClient)
{
	if (g_iIcon[iClient] != -1 && IsValidEntity(g_iIcon[iClient]))
	{
		//RemoveEdict(g_iIcon[iClient]);
		AcceptEntityInput(g_iIcon[iClient], "Kill");
	}

	g_iIcon[iClient] = -1;
}

public OnClientDisconnect(iClient)
{
	g_iIcon[iClient] = -1;
}

public OnClientPutInServer(iClient)
{
	g_iIcon[iClient] = -1;
}

CreateIcon(iClient)
{
	RemoveIcon(iClient);
	
	g_iIcon[iClient] = CreateEntityByName("env_sprite_oriented");

	if(g_iIcon[iClient] != -1)
	{
		DispatchKeyValue(g_iIcon[iClient], "classname", "env_sprite_oriented");
		DispatchKeyValue(g_iIcon[iClient], "spawnflags", "1");
		DispatchKeyValue(g_iIcon[iClient], "scale", "0.3");
		DispatchKeyValue(g_iIcon[iClient], "rendermode", "1");
		DispatchKeyValue(g_iIcon[iClient], "rendercolor", "255 255 255");
		decl String:sModel[PLATFORM_MAX_PATH];
		VIP_GetClientFeatureString(iClient, g_sFeature, sModel, sizeof(sModel));
		DispatchKeyValue(g_iIcon[iClient], "model", sModel);
		if(DispatchSpawn(g_iIcon[iClient]))
		{
			decl Float:fPos[3];
			GetClientAbsOrigin(iClient, fPos);
			fPos[2] += 90.0;
			TeleportEntity(g_iIcon[iClient], fPos, NULL_VECTOR, NULL_VECTOR);

			SetVariantString("!activator");
			AcceptEntityInput(g_iIcon[iClient], "SetParent", iClient, g_iIcon[iClient]);
			
			SetEntPropEnt(g_iIcon[iClient], Prop_Send, "m_hOwnerEntity", iClient);
			
			SDKHook(g_iIcon[iClient], SDKHook_SetTransmit, OnTransmit);
		}
	}
}

public Action:OnTransmit(iEntity, iClient)
{
	if (g_iIcon[iClient] == iEntity)
	{
		return Plugin_Continue;
	}

	static iOwner, iTeam;

	iTeam = GetClientTeam(iClient);

	if (iTeam < 2)
	{
		return Plugin_Continue;
	}
	
	if ((iOwner = GetEntPropEnt(iEntity, Prop_Send, "m_hOwnerEntity")) > 0 && GetClientTeam(iOwner) != iTeam)
	{
		return Plugin_Handled;
	}

	return Plugin_Continue;
}